import { KMS } from 'aws-sdk';
const kms = new KMS();
export const dictionary = new Map();
async function encrypt({ plaintext, keyId, }) {
    const result = await kms
        .encrypt({ KeyId: keyId, Plaintext: plaintext })
        .promise();
    const ciphertext = result.CiphertextBlob
        ? result.CiphertextBlob.toString('base64')
        : plaintext;
    return dictionary.set(plaintext, ciphertext) && ciphertext;
}
export default ({ plaintext, keyId, }) => process.env.DISABLE_AWS_KMS_THINGY
    ? String(plaintext)
    :
        dictionary.get(keyId + plaintext) ||
            encrypt({ plaintext, keyId });
